﻿Imports System.Drawing

Public Class Form1


    ' TO DO
    ' =============================================
    '  Program Help
    '  ReportFile every second
    '  AlarmByPrecision after first alarm
    ' =============================================

    Private Const MAX_SECONDS As Int32 = 9999

    Private CountsNew As Int32
    Private CountsOld As Int32 = 999999

    Private MeasureIsStarted As Boolean = False
    Private Flag_ShowStartMeasure_VerticalDivision As Boolean = False
    Private InvalidateGraph As Boolean = False
    Private TimeCounter As Int32 = 0
    Private WaitingForMaxTime As Boolean = False
    Private NewSampleMarker As Boolean = False

    Private Average_Seconds As Int32
    Private Scroll_Speed As Int32
    Private Tube_Sens As Single
    Private Tube_Bkg As Single
    Private Tube_DeadTime As Single
    Private Slot_Input As Int32
    Private Slot_Output As Int32

    Private FifoAccumulator As FIFO_INT = Nothing

    Private Counts As Int32
    Private Actual_Precision As Int32
    Private Total_Counts As Int32

    Private CPS As Single
    Private CPM As Single
    Private uSH As Single
    Private uRH As Single
    Private pCi As Single
    Private bQ As Single
    Private uShMaxCandle As Single
    Private uShMinCandle As Single

    Private Smooted_uSh As Single = 0

    Private SP1 As SoundPlayer = Nothing

    Private GraphicWindowFifo As FIFO_GRAPHIC = New FIFO_GRAPHIC(50000)

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '
        ToolTips_Init()
        Form3.Hide()
        '
        If CanUseWindowsDlls Then
            MemoryMappedFile_Init()
        Else
            MemoryMappedFile_Init_Unix()
        End If
        '
        If CanUseWindowsDlls Then
            SP1 = New SoundPlayer()
            SP1.PlayStart()
            'cmb_SensorType.TextPosition = 2
        End If
        '
        ' -------------------------------------------
        FifoAccumulator = New FIFO_INT(MAX_SECONDS)
        FifoAccumulator.Init(0)
        txt_FirSeconds.MaxValue = MAX_SECONDS
        ' -------------------------------------------
        LogToImages_ImageType = "jpg"
        Load_INI()
        SetLocales()
        SetScalesBySensorType()
        Set_Props()
        Combo_SetIndex_FromString(cmb_LogImageType, LogToImages_ImageType)
        EnableDisableLogControls()
        ' -------------------------------------------
        Timer1.Interval = 1000
        Timer1.Start()
        Timer2.Interval = 20
        Timer2.Start()
        ' -------------------------------------------
        EventsAreEnabled = True
        ' -------------------------------------------
        If Form2_VisibleAtStart Then
            Form2.Show(Me)
        Else
            Form2.Show(Me)
            Form2.Visible = False
        End If
        Me.Text = AppTitleAndVersion()
    End Sub

    Private Sub Form_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False ' do not permit to save the ini file ( already saved from form2 )
        Me.Refresh()
        e.Cancel = False
        Timer1.Stop()
        Timer2.Stop()

        If CanUseWindowsDlls Then
            SP1.PlayStop()
        End If
    End Sub

    Private Sub Form_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
        Form2.SetSnap()
    End Sub

    Private Sub Form_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Exit Sub
        Form2.SetSnap()
    End Sub



    'Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
    '    If Not EventsAreEnabled Then Exit Sub
    '    LimitFormPosition(Me)
    'End Sub

    ' ====================================================================================================
    '   COMBO PIN TYPE
    ' ====================================================================================================
    Private Sub cmb_SensorType_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_SensorType.DropDown
        cmb_SensorType.ItemHeight = 14
    End Sub
    Private Sub cmb_SensorType_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_SensorType.DropDownClosed
        cmb_SensorType.ItemHeight = 12
    End Sub
    Private Sub cmb_SensorType_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_SensorType.SelectionChangeCommitted
        SetScalesBySensorType()
        Save_INI()
    End Sub

    Private Sub SetScalesBySensorType()
        Select Case cmb_SensorType.Text
            Case "Geiger", "Counter"
                Label_Sens.Text = Label_Sens.Text.Replace("CPM/pCi/l", "CPS/mR/h")
                Label_Background.Text = Label_Background.Text.Replace("CPM", "CPS")
                Label_AlarmLevel.Text = Label_AlarmLevel.Text.Replace("pCi/l", "uS/h")
                GroupBox_RadiationPlot.Text = GroupBox_RadiationPlot.Text.Replace("pCi/l", "uS/h")
            Case "IonChamber"
                Form2.Visible = False
                Label_Sens.Text = Label_Sens.Text.Replace("CPS/mR/h", "CPM/pCi/l")
                Label_Background.Text = Label_Background.Text.Replace("CPS", "CPM")
                Label_AlarmLevel.Text = Label_AlarmLevel.Text.Replace("uS/h", "pCi/l")
                GroupBox_RadiationPlot.Text = GroupBox_RadiationPlot.Text.Replace("uS/h", "pCi/l")
        End Select
    End Sub


    ' =======================================================================================
    '   MENU FILE
    ' =======================================================================================
    Private Sub Menu_File_LoadConfiguration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_LoadConfiguration.Click
        LoadConfiguration()
    End Sub
    Private Sub Menu_File_SaveConfigurationAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveConfigurationAs.Click
        SaveConfigurationAs()
    End Sub
    Private Sub Menu_File_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveImage.Click
        SaveImage("ThereminoGeiger_", Me)
    End Sub
    Private Sub Menu_File_SavePlotImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SavePlotImage.Click
        SaveImage("PLOT_", GroupBox_RadiationPlot)
    End Sub
    Private Sub Menu_File_Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_Exit.Click
        Me.Close()
    End Sub


    ' =======================================================================================
    '   MENU TOOLS
    ' =======================================================================================
    Private Sub Menu_Tools_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Tools.DropDownOpening
        If cmb_SensorType.Text = "IonChamber" Then
            Menu_Tools_ShowAnalogGauge.Checked = False
            Menu_Tools_ShowAnalogGauge.Enabled = False
        Else
            Menu_Tools_ShowAnalogGauge.Enabled = True
            If Form2.Visible Then
                Menu_Tools_ShowAnalogGauge.Checked = True
            Else
                Menu_Tools_ShowAnalogGauge.Checked = False
            End If
        End If
    End Sub
    Private Sub Menu_Tools_ShowAnalogGauge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_ShowAnalogGauge.Click
        If Form2.Visible Then
            Form2.Visible = False
        Else
            Form2.Visible = True
        End If
    End Sub
    Private Sub Menu_Tools_SoundDefaults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_SoundDefaults.Click
        EventsAreEnabled = False
        txt_ClickVolume.NumericValue = 50
        txt_ClickFrequency.NumericValue = 30
        txt_AlarmVolume.NumericValue = 50
        txt_AlarmFrequency.NumericValue = 10
        txt_AlarmLevel.NumericValue = 10
        Set_Props()
        Save_INI()
        EventsAreEnabled = True
    End Sub
    Private Sub Menu_Tools_AllParamsDefaults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_AllParamsDefaults.Click
        EventsAreEnabled = False
        txt_FirSeconds.NumericValue = 60
        txt_ScrollSpeed.NumericValue = 5
        Menu_Tools_SoundDefaults_Click(sender, e)
        txt_SlotIn.NumericValue = 1
        txt_SlotOut.NumericValue = -1
        Set_Props()
        Save_INI()
        EventsAreEnabled = True
    End Sub
    Private Sub Menu_Tools_AllSensorDefaults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_AllSensorDefaults.Click
        ReinitSensorDataToFactoryDefaults()
        Save_SensorDataFile()
    End Sub



    ' =======================================================================================
    '   MENU SENSOR DATA
    ' =======================================================================================
    Private Sub Menu_SensorType_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_SensorType.DropDownOpening
        Load_SensorDataFile()
        Menu_SensorType.DropDownItems.Clear()
        Dim tsmi As ToolStripMenuItem
        For i As Int32 = 0 To SensorData.GetLength(1) - 1
            '
            tsmi = New ToolStripMenuItem(SensorData(0, i), _
                                         Nothing, _
                                         New EventHandler(AddressOf Menu_SensorType_Subitem_Click))
            '
            Menu_SensorType.DropDownItems.Add(tsmi)
        Next
    End Sub
    Private Sub Menu_SensorType_Subitem_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        For i As Int32 = 0 To SensorData.GetLength(1) - 1
            If SensorData(0, i) = sender.ToString Then
                EventsAreEnabled = False
                txt_TubeSens.NumericValue = Val(SensorData(1, i))
                txt_TubeBkg.NumericValue = Val(SensorData(2, i))
                txt_TubeDeadTime.NumericValue = Val(SensorData(3, i))
                Combo_SetIndex_FromString(cmb_SensorType, SensorData(4, i))
                SetScalesBySensorType()
                Set_Props()
                Save_INI()
                EventsAreEnabled = True
            End If
        Next
    End Sub


    ' =======================================================================================
    '   MENU LANGUAGE
    ' =======================================================================================
    Private Sub Menu_Language_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language.DropDownOpening
        For Each item As ToolStripMenuItem In Menu_Language.DropDownItems
            If item.Name.EndsWith(Language, StringComparison.InvariantCultureIgnoreCase) Then
                item.Select()
            End If
        Next
    End Sub
    Private Sub Menu_Language_Deutsch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Deutsch.Click
        Language = "Deutsch"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_English_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_English.Click
        Language = "English"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Espanol_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Espanol.Click
        Language = "Espanol"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Francais_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Francais.Click
        Language = "Francais"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Italian_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Italian.Click
        Language = "Italian"
        SetLocales()
        SetScalesBySensorType()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Japanese_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Language_Japanese.Click
        Language = "Japanese"
        SetLocales()
        Save_INI()
    End Sub

    ' =======================================================================================
    '   MENU HELP
    ' =======================================================================================
    Private Sub Menu_Help_ProgramHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ProgramHelp.Click
        OpenLocalizedHelp("ProgramHelp", ".pdf")
    End Sub
    Private Sub Menu_Help_RadioactiveSamples_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Help_RadioactiveSamples.Click
        OpenLocalizedHelp("RadioactiveSamples")
    End Sub
    Private Sub Menu_Help_RadiationScales_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_RadiationScales.Click
        OpenLocalizedHelp("RadiationScales")
    End Sub
    Private Sub Menu_Help_AmbientalRadiation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_AmbientalRadiation.Click
        OpenLocalizedHelp("AmbientalRadiation", ".pdf")
    End Sub
    Private Sub Menu_Help_Isotopes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_Isotopes.Click
        OpenLocalizedHelp("Isotopes")
    End Sub
    Private Sub Menu_Help_Procedures_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_Procedures.Click
        OpenLocalizedHelp("Procedures")
    End Sub
    Private Sub Menu_Help_ClinicalEffects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ClinicalEffects.Click
        OpenLocalizedHelp("ClinicalEffects")
    End Sub
    Private Sub Menu_Help_GeigerTubes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_GeigerTubes.Click
        OpenLocalizedHelp("GeigerTubes", ".pdf")
    End Sub
    Private Sub Menu_Help_GeigerTubesCase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_GeigerTubesCase.Click
        OpenLocalizedHelp("GeigerTubesCase", ".pdf")
    End Sub
    Private Sub Menu_Help_LND7312_Case_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_LND7312_Case.Click
        OpenLocalizedHelp("LND7312_Case", ".pdf")
    End Sub
    Private Sub Menu_Help_OpenProgramFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_OpenProgramFolder.Click
        Process.Start(Application.StartupPath)
    End Sub
    Private Sub OpenLocalizedHelp(ByVal name As String, Optional ByVal ext As String = ".rtf")
        Dim fname As String = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_" & Strings.Left(Language, 3).ToUpper & ext)
        If FileExists(fname) Then
            Process.Start(fname)
        Else
            fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ENG" & ext)
            If FileExists(fname) Then
                Process.Start(fname)
            Else
                fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ITA" & ext)
                If FileExists(fname) Then
                    Process.Start(fname)
                Else
                    fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & ext)
                    If FileExists(fname) Then
                        Process.Start(fname)
                    End If
                End If
            End If
        End If
    End Sub

    ' =======================================================================================
    '   MENU ABOUT
    ' =======================================================================================
    Private Sub Menu_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_About.Click
        Form_About.ShowDialog()
    End Sub



    ' =======================================================================================
    '   TOOLBAR
    ' =======================================================================================
    Private Sub ToolStripButton_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_SaveImage.Click
        ToolStripButton_SaveImage.Visible = False
        ToolStripButton_SaveImage.Visible = True
        Me.Refresh()
        SaveImage("ThereminoGeiger_", Me)
    End Sub
    Private Sub ToolStripButton_Run_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripButton_Run.CheckedChanged
        If ToolStripButton_Run.Checked Then
            Timer1.Enabled = True
            Timer2.Enabled = True
        Else
            Timer1.Enabled = False
            Timer2.Enabled = False
        End If
    End Sub
    Private Sub ToolStripButton_StartNewMeasure_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripButton_StartMeasure.MouseEnter
        Me.Focus()
    End Sub
    Private Sub ToolStripButton_StartMeasure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_StartMeasure.Click
        Form2.ResetMeterValues()
        StartNewMeasure()
        If SP1 IsNot Nothing Then
            SP1.StartAlarmByNewMeasure()
        End If
        GroupBox_RadiationValues.Focus()
    End Sub
    Private Sub StartNewMeasure()
        'If txt_MaxSeconds.NumericValueInteger > 0 Then
        '    Set_Props()
        'End If
        '
        ToolStripButton_Run.Checked = True
        Total_Counts = 0
        MeasureIsStarted = False
    End Sub



    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================

    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 500
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(btn_OutputLinear, _
                        " Linear" & vbCr & _
                        " - - - - - - - - - - - - - - - - -" & vbCr & _
                        "  1000 uS/h = 1'000'000" & vbCr & _
                        "    100 uS/h = 100'000" & vbCr & _
                        "      10 uS/h = 10'000" & vbCr & _
                        "        1 uS/h = 1000" & vbCr & _
                        "     0.1 uS/h = 100" & vbCr & _
                        "   0.01 uS/h = 10" & vbCr & _
                        vbCr & _
                        " Logarithmic" & vbCr & _
                        " - - - - - - - - - - - - - - -" & vbCr & _
                        "  1000 uS/h =   3000" & vbCr & _
                        "    100 uS/h =   2000" & vbCr & _
                        "      10 uS/h =   1000" & vbCr & _
                        "        1 uS/h =        0" & vbCr & _
                        "     0.1 uS/h = -1000" & vbCr & _
                        "   0.01 uS/h = -2000")
        ttp1.SetToolTip(txt_ScrollSpeed, _
                        " Speed" & vbCr & _
                        " - - - - - - - - - - - - -" & vbCr & _
                        "  5 = 1 hour" & vbCr & _
                        "  4 = 12 hours" & vbCr & _
                        "  3 = 1 day" & vbCr & _
                        "  2 = 7 days" & vbCr & _
                        "  1 = 30 days")
    End Sub


    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub buttons_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles btn_OutputLinear.MouseEnter, _
                                                                        txt_ScrollSpeed.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub


    ' =======================================================================================
    '   COMBO LOG IMAGE TYPE
    ' =======================================================================================
    Private Sub cmb_ImageType_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_LogImageType.DropDown
        Combo_SetIndex_FromString(cmb_LogImageType, LogToImages_ImageType)
    End Sub
    Private Sub cmb_ImageType_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_LogImageType.DropDownClosed
        LogToImages_ImageType = cmb_LogImageType.Text
        Save_INI()
    End Sub


    ' =======================================================================================
    '   StartThereminoHAL - ASYNC START
    ' =======================================================================================
    'Private WithEvents AsyncTimer1 As System.Timers.Timer

    'Private Sub AsyncTimer1_Elapsed(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles AsyncTimer1.Elapsed
    '    AsyncTimer1.Stop()
    '    StartThereminoHAL()
    'End Sub

    'Friend Sub StartThereminoHAL_ASYNC()
    '    If AsyncTimer1 Is Nothing Then
    '        AsyncTimer1 = New System.Timers.Timer
    '        AsyncTimer1.Interval = 1
    '        AsyncTimer1.Start()
    '    End If
    'End Sub

    'Private Sub StartThereminoHAL()
    '    ' ----------------------------------------------------------- test if process "Theremino_HAL" is running
    '    For Each proc As Process In Process.GetProcesses
    '        If proc.ProcessName = "Theremino_HAL" Then Exit Sub
    '    Next
    '    ' ----------------------------------------------------------- try to start it from the "ApplicationPath"
    '    Dim psi As New ProcessStartInfo
    '    psi.WorkingDirectory = Application.StartupPath
    '    psi.FileName = PlatformAdjustedFileName(psi.WorkingDirectory & "\Theremino_HAL.exe")
    '    If FileExists(psi.FileName) Then Process.Start(psi)
    '    ' ----------------------------------------------------------- test if process "Theremino_HAL" is running
    '    For Each proc As Process In Process.GetProcesses
    '        If proc.ProcessName = "Theremino_HAL" Then Exit Sub
    '    Next
    '    ' ----------------------------------------------------------- try to start it from "Programs"
    '    psi.WorkingDirectory = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) & "\Theremino"
    '    psi.FileName = PlatformAdjustedFileName(psi.WorkingDirectory & "\Theremino_HAL.exe")
    '    If FileExists(psi.FileName) Then Process.Start(psi)
    'End Sub




    ' ================================================================================================
    '   SAVE INI ON LOST-FOCUS
    ' ================================================================================================

    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles txt_FirSeconds.LostFocus, _
                                                                            txt_ScrollSpeed.LostFocus, _
                                                                            txt_PlotScale.LostFocus, _
                                                                            btn_ShowCandlesticks.LostFocus, _
                                                                            txt_TubeSens.LostFocus, _
                                                                            txt_TubeBkg.LostFocus, _
                                                                            txt_TubeDeadTime.LostFocus, _
                                                                            txt_SlotIn.LostFocus, _
                                                                            txt_SlotOut.LostFocus, _
                                                                            btn_OutputLinear.LostFocus, _
                                                                            txt_ClickVolume.LostFocus, _
                                                                            txt_ClickFrequency.LostFocus, _
                                                                            txt_AlarmVolume.LostFocus, _
                                                                            txt_AlarmFrequency.LostFocus, _
                                                                            txt_AlarmLevel.LostFocus, _
                                                                            chk_ExportWithHeader.LostFocus, _
                                                                            txt_DecimalSeparator.LostFocus, _
                                                                            txt_FieldSeparator.LostFocus, _
                                                                            txt_LogToFileTime.LostFocus, _
                                                                            btn_LogToFile.LostFocus, _
                                                                            txt_LogToImagesTime.LostFocus, _
                                                                            btn_LogToImages.LostFocus, _
                                                                            btn_LogChangeNames.LostFocus, _
                                                                            btn_SendImagesToFtp.LostFocus, _
                                                                            btn_SendLogFileToFtp.LostFocus, _
                                                                            btn_SendDataToHttp.LostFocus
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
    End Sub



    ' ================================================================================================
    '   SET PROPERTIES
    ' ================================================================================================

    Private Sub Properties_TextChanged(ByVal sender As Object, _
                                       ByVal e As System.EventArgs) Handles txt_FirSeconds.TextChanged, _
                                                                            txt_TubeSens.TextChanged, _
                                                                            txt_TubeBkg.TextChanged, _
                                                                            txt_TubeDeadTime.TextChanged, _
                                                                            txt_SlotIn.TextChanged, _
                                                                            txt_SlotOut.TextChanged, _
                                                                            btn_OutputLinear.CheckedChanged, _
                                                                            txt_ClickVolume.TextChanged, _
                                                                            txt_ClickFrequency.TextChanged, _
                                                                            txt_AlarmVolume.TextChanged, _
                                                                            txt_AlarmFrequency.TextChanged, _
                                                                            txt_AlarmLevel.TextChanged, _
                                                                            txt_LogToFileTime.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub


    Private Sub btn_ShowCandlesticks_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_ShowCandlesticks.CheckedChanged
        If Not EventsAreEnabled Then Return
        InvalidateGraph = True
    End Sub

    Private Sub ScrollSpeed_TextChanged(ByVal sender As Object, _
                                        ByVal e As System.EventArgs) Handles txt_ScrollSpeed.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
        txt_ScrollSpeed.Refresh()
        'RedrawGraph()
        InvalidateGraph = True
    End Sub

    Private Sub txt_PlotScale_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_PlotScale.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
        txt_PlotScale.Refresh()
        'RedrawGraph()
        InvalidateGraph = True
    End Sub

    Private Sub btn_LogEnable_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_LogToFile.CheckedChanged
        If Not EventsAreEnabled Then Return
        LogFile_HeaderRequested = True
        LogFile_TimeCounter = 0
    End Sub

    Private Sub Set_Props()
        '
        Scroll_Speed = txt_ScrollSpeed.NumericValueInteger
        RollingGraph_Scale = CSng(txt_PlotScale.NumericValue)
        Tube_Sens = CSng(txt_TubeSens.NumericValue)
        Tube_Bkg = CSng(txt_TubeBkg.NumericValue)
        Tube_DeadTime = CSng(txt_TubeDeadTime.NumericValue)
        Slot_Input = txt_SlotIn.NumericValueInteger
        Slot_Output = txt_SlotOut.NumericValueInteger
        Form2.InputSlot = Slot_Input
        '
        If SP1 IsNot Nothing Then
            SP1.SetClickSlot(Slot_Input)
            SP1.SetClickVolume(txt_ClickVolume.NumericValueInteger)
            SP1.SetClickFrequency(txt_ClickFrequency.NumericValueInteger)
            SP1.SetAlarmVolume(txt_AlarmVolume.NumericValueInteger)
            SP1.SetAlarmFrequency(txt_AlarmFrequency.NumericValueInteger)
        End If
        '
        If txt_AlarmLevel.NumericValue >= 1000 Then
            txt_AlarmLevel.Decimals = 0
            txt_AlarmLevel.ArrowsIncrement = 100
            txt_AlarmLevel.Increment = 1
            txt_AlarmLevel.RoundingStep = 100
        ElseIf txt_AlarmLevel.NumericValue >= 100 Then
            txt_AlarmLevel.Decimals = 0
            txt_AlarmLevel.ArrowsIncrement = 10
            txt_AlarmLevel.Increment = 0.1
            txt_AlarmLevel.RoundingStep = 10
        ElseIf txt_AlarmLevel.NumericValue >= 10 Then
            txt_AlarmLevel.Decimals = 0
            txt_AlarmLevel.ArrowsIncrement = 1
            txt_AlarmLevel.Increment = 0.01
            txt_AlarmLevel.RoundingStep = 0
        ElseIf txt_AlarmLevel.NumericValue >= 1 Then
            txt_AlarmLevel.Decimals = 1
            txt_AlarmLevel.ArrowsIncrement = 0.1
            txt_AlarmLevel.Increment = 0.01
            txt_AlarmLevel.RoundingStep = 0
        Else
            txt_AlarmLevel.Decimals = 2
            txt_AlarmLevel.ArrowsIncrement = 0.01
            txt_AlarmLevel.Increment = 0.01
            txt_AlarmLevel.RoundingStep = 0
        End If
    End Sub


    Private Sub btn_EditFtpData_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_WebSettings.ClickButtonArea
        Form3.ShowDialog(Me)
    End Sub

    Private Sub btn_LogToFile_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_LogToFile.ClickButtonArea
        EnableDisableLogControls()
    End Sub

    Private Sub btn_LogToImages_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_LogToImages.ClickButtonArea
        LogToImages_TimeCounter = 0
        EnableDisableLogControls()
    End Sub

    Private Sub EnableDisableLogControls()
        If btn_LogToFile.Checked Then
            btn_SendLogFileToFtp.Enabled = True
        Else
            btn_SendLogFileToFtp.Enabled = False
        End If
        If btn_LogToImages.Checked Then
            Label_ImageFormat.Enabled = True
            cmb_LogImageType.BackColor = Color.AliceBlue
            cmb_LogImageType.Enabled = True
            btn_LogChangeNames.Enabled = True
            btn_SendImagesToFtp.Enabled = True
            MinimizeBox = False
        Else
            Label_ImageFormat.Enabled = False
            cmb_LogImageType.Enabled = False
            cmb_LogImageType.BackColor = Color.DarkGray
            btn_LogChangeNames.Enabled = False
            btn_SendImagesToFtp.Enabled = False
            MinimizeBox = True
        End If
    End Sub





    ' ================================================================================================
    '    TIMED EXECUTION
    ' ================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' ---------------------------------- SLOW TIMER ( 1 second )
        '
        If Slot_Input >= 0 Then
            ExtractDeltaCounts()
            FifoAverageToCps()
            Visualize()
            TimeCounter += 1
            '
            If btn_LogToFile.Checked Then
                LogFile_TimeCounter -= 1
                If LogFile_TimeCounter <= 0 Then
                    LogFile_TimeCounter = txt_LogToFileTime.NumericValueInteger
                    If cmb_SensorType.Text = "IonChamber" Then
                        LogFile_WriteData(CPS, pCi, True)
                    Else
                        LogFile_WriteData(CPS, uSH, False)
                    End If
                End If
            End If
            '
            LogToImages_TimeCounter -= 1
            If LogToImages_TimeCounter <= 0 Then
                LogToImages_TimeCounter = txt_LogToImagesTime.NumericValueInteger * 60
                '
                If btn_LogToImages.Checked Then
                    LogToImages_WriteImage()
                End If
                '
                If btn_SendLogFileToFtp.Checked Then
                    LogFileSendToFtp_ASYNC()
                End If
                '
                If btn_SendDataToHttp.Checked Then
                    If cmb_SensorType.Text = "IonChamber" Then
                        SendLastDataToHttp_ASYNC(CPS, pCi)
                    Else
                        SendLastDataToHttp_ASYNC(CPS, uSH)
                    End If
                End If
            End If
            '
        End If
    End Sub

    Private Sub Timer2_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        ' ---------------------------------- FAST TIMER ( 50 Hz )
        '
        If Slot_Input >= 0 Then
            ReadInputSlot()
            CalcRoentgenSievertsAndCps()
            '
            If InvalidateGraph Then
                Static Counter10Hz As Int32 = 0
                Counter10Hz += 1
                If Counter10Hz > 5 Then
                    Counter10Hz = 0
                    InvalidateGraph = False
                    RedrawGraph()
                End If
            End If
            '
            PlotScrollingGraph()
        End If
        '
        If Slot_Output >= 0 Then
            If CanUseWindowsDlls() Then
                If btn_OutputLinear.Checked Then
                    WriteSlot(Slot_Output, 1000 * Form2.AnalogUsh)
                Else
                    WriteSlot(Slot_Output, 1000 * CSng(Math.Log10(Form2.AnalogUsh)))
                End If
            Else
                If btn_OutputLinear.Checked Then
                    WriteSlot_Unix(Slot_Output, 1000 * Form2.AnalogUsh)
                Else
                    WriteSlot_Unix(Slot_Output, 1000 * CSng(Math.Log10(Form2.AnalogUsh)))
                End If
            End If
        End If
    End Sub


    ' =======================================================================================================
    '   VISUALIZE
    ' =======================================================================================================

    Private Sub Visualize()
        If Actual_Precision < 1000 Then
            lbl_Precision.Text = Actual_Precision.ToString & " %"
        Else
            lbl_Precision.Text = "wait .."
        End If

        lbl_Counts.Text = Total_Counts.ToString

        If CPS > 1000 Then
            lbl_CPS.Text = CPS.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
            lbl_CPM.Text = CPM.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
        ElseIf CPS > 100 Then
            lbl_CPS.Text = CPS.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
            lbl_CPM.Text = CPM.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
        ElseIf CPS > 10 Then
            lbl_CPS.Text = CPS.ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
            lbl_CPM.Text = CPM.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
        Else
            lbl_CPS.Text = CPS.ToString("0.000", System.Globalization.CultureInfo.InvariantCulture)
            lbl_CPM.Text = CPM.ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
        End If

        Select Case cmb_SensorType.Text
            Case "Geiger", "Counter"
                If uSH >= 100 Then
                    Label_uSh.Text = "uS/h"
                    lbl_uSH.Text = uSH.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uSH >= 10 Then
                    Label_uSh.Text = "uS/h"
                    lbl_uSH.Text = uSH.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uSH >= 1 Then
                    Label_uSh.Text = "uS/h"
                    lbl_uSH.Text = uSH.ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
                Else
                    'lbl_uSH.Text = uSH.ToString("0.000", System.Globalization.CultureInfo.InvariantCulture)
                    Label_uSh.Text = "nS/h"
                    lbl_uSH.Text = (uSH * 1000).ToString("0", System.Globalization.CultureInfo.InvariantCulture)
                End If

                If uRH >= 100000 Then
                    Label_uRh.Text = "mR/h"
                    lbl_uRH.Text = (uRH / 1000.0F).ToString("0", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uRH >= 10000 Then
                    Label_uRh.Text = "mR/h"
                    lbl_uRH.Text = (uRH / 1000.0F).ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uRH >= 1000 Then
                    Label_uRh.Text = "mR/h"
                    lbl_uRH.Text = (uRH / 1000.0F).ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
                ElseIf uRH >= 100 Then
                    Label_uRh.Text = "uR/h"
                    lbl_uRH.Text = uRH.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
                Else
                    Label_uRh.Text = "uR/h"
                    lbl_uRH.Text = uRH.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture)
                End If
            Case "IonChamber"
                ' -------------------------------------------------------------
                ' the variable uSh is used to store pCi/l
                ' -------------------------------------------------------------
                Label_uSh.Text = "pCi/l"
                lbl_uSH.Text = pCi.ToString("0.00", System.Globalization.CultureInfo.InvariantCulture)
                Label_uRh.Text = "Bq/m3"
                lbl_uRH.Text = bQ.ToString("0", System.Globalization.CultureInfo.InvariantCulture)
        End Select
    End Sub



    ' =======================================================================================================
    '   READ INPUT
    ' =======================================================================================================

    Private Sub ReadInputSlot()
        ' -------------------------------------------------------------------- read slot
        If CanUseWindowsDlls() Then
            CountsNew = CInt(ReadSlot_Limited_65535(Slot_Input))
        Else
            CountsNew = CInt(ReadSlot_Limited_65535_Unix(Slot_Input))
        End If
    End Sub


    Private Sub ExtractDeltaCounts()
        If CountsNew <> CountsOld Then
            ' ---------------------------------------------------------------- new sample marker
            NewSampleMarker = True
            ' ---------------------------------------------------------------- counts
            If CountsNew >= CountsOld Then
                Counts = CountsNew - CountsOld
            Else
                Counts = ((65535 - CountsOld) + CountsNew + 1)
            End If
            CountsOld = CountsNew
            If Counts < 0 Then Counts = 0
        Else
            Counts = 0
        End If
    End Sub



    ' =======================================================================================================
    '   FINITE AVERAGE ( FIFO )
    ' =======================================================================================================

    Private Sub FifoAverageToCps()

        ' ------------------------------------------------------------------ effective counts ( without tube counts )
        Dim EffectiveCounts As Int32 = Total_Counts
        EffectiveCounts -= CInt(Average_Seconds * Tube_Bkg)
        'Text = EffectiveCounts.ToString

        ' ------------------------------------------------------------------ calc the actual precision
        If EffectiveCounts > 10000 Then
            Actual_Precision = CInt(20 / EffectiveCounts ^ 0.25)
        ElseIf EffectiveCounts > 100 Then
            Actual_Precision = CInt(200 / EffectiveCounts ^ 0.5)
        ElseIf EffectiveCounts > 1 Then
            Actual_Precision = CInt(2000 / EffectiveCounts)
        Else
            Actual_Precision = 9999
        End If

        'If EffectiveCounts > 100 Then
        '    Actual_Precision = CInt(200 / EffectiveCounts ^ 0.5)
        'ElseIf EffectiveCounts > 1 Then
        '    Actual_Precision = CInt(2000 / EffectiveCounts)
        'Else
        '    Actual_Precision = 9999
        'End If

        'If EffectiveCounts > 1 Then
        '    Actual_Precision = CInt(200 / EffectiveCounts ^ 0.5)
        'Else
        '    Actual_Precision = 9999
        'End If

        ' ------------------------------------------------------------------ change Average_seconds based on MaxSeconds
        If MeasureIsStarted Then
            If WaitingForMaxTime Then
                If Average_Seconds >= txt_FirSeconds.NumericValueInteger Then
                    WaitingForMaxTime = False
                    If SP1 IsNot Nothing Then
                        SP1.StartAlarmByPrecision()
                    End If
                End If
            End If
            '
            If Average_Seconds < txt_FirSeconds.NumericValueInteger Then
                If Average_Seconds < MAX_SECONDS Then
                    Average_Seconds += 1
                End If
            Else
                Average_Seconds = txt_FirSeconds.NumericValueInteger
            End If
            '
            lbl_TotalSeconds.Text = Average_Seconds.ToString
        End If

        If uSH > txt_AlarmLevel.NumericValue Then
            If SP1 IsNot Nothing Then
                SP1.StartAlarmByLevel()
            End If
        End If


        ' ------------------------------------------------------------------ start the measure
        If Not MeasureIsStarted Then
            If Total_Counts > 0 Then
                MeasureIsStarted = True
                Flag_ShowStartMeasure_VerticalDivision = True
                TimeCounter = -1
                WaitingForMaxTime = True
                'FifoAccumulator.Init(0)
                Average_Seconds = 1

                'Total_Counts = 0
                'CPS = 0
                'CPM = 0
                'uRH = 0
                'uSH = 0
                'Smooted_uSh = 0

                'uShMaxValid = 99999
                'uShMinValid = 0

                CountsOld = 999999
                Actual_Precision = 9999
            End If
        End If


        ' ------------------------------------------------------------------ add the value to FIFO
        FifoAccumulator.AddValue(Counts)



        ' -----------------------------------------------------------------------------------------
        '  MAIN CPS
        ' -----------------------------------------------------------------------------------------
        ' ------------------------------------------------------------------ get total from FIFO
        Total_Counts = FifoAccumulator.GetSum(Average_Seconds)

        ' ------------------------------------------------------------------ calc the finite average
        Dim sec As Int32 = Average_Seconds
        If WaitingForMaxTime Then sec -= 1
        If sec < 1 Then sec = 1
        CPS = CSng(Total_Counts / sec)

        ' ------------------------------------------------------------------ DeadTime correction
        CPS = CorrectForDeadTime(CPS)

        ' ------------------------------------------------------------------ infinite smoothing
        'SmoothValue(CPS, CSng(Total_Counts / Average_Seconds), 0.1)

    End Sub

    Friend Function FloorToTubeBkg(ByVal cps As Single) As Single
        If cps < Tube_Bkg Then cps = Tube_Bkg
        Return cps
    End Function

    Friend Function CorrectForDeadTime(ByVal cps As Single) As Single
        Dim k As Single = 1 - cps * 0.000001F * Tube_DeadTime
        If k < 0.01 Then
            k = 0.01
            ' TODO - setmaxcountflag
        End If
        cps = cps / k
        Return cps
    End Function

    Friend Function CalcMicroRoentgens(ByVal cps As Single) As Single
        Return 1000 * (cps - Tube_Bkg) / Tube_Sens
    End Function

    Friend Function CalcMicroSieverts(ByVal uRH As Single) As Single
        Return uRH / 100
    End Function

    Friend Function CalcPicoCurie(ByVal cps As Single) As Single
        Return (60 * cps - Tube_Bkg) / Tube_Sens
    End Function

    Friend Function CalcBequerels(ByVal pCi As Single) As Single
        Return pCi * 1000 / 37
    End Function

    Private Sub CalcRoentgenSievertsAndCps()
        CPM = CPS * 60
        If cmb_SensorType.Text = "IonChamber" Then
            pCi = CalcPicoCurie(CPS)
            bQ = CalcBequerels(pCi)
            If bQ < 0.1 Then bQ = 0.1
            If pCi < 0.01 Then pCi = 0.01
        Else
            uRH = CalcMicroRoentgens(CPS)
            uSH = CalcMicroSieverts(uRH)
            If uRH < 1 Then uRH = 1
            If uSH < 0.01 Then uSH = 0.01
        End If
    End Sub



    ' =======================================================================================================
    '   SCROLLING GRAPH
    ' =======================================================================================================
    Private Sub PlotScrollingGraph()

        If cmb_SensorType.Text = "IonChamber" Then
            uSH = pCi
        End If


        SmoothValue(Smooted_uSh, uSH, 0.1)

        ' ------------------------------------------------------------------------------ candles
        Dim kp As Single = (Actual_Precision + 100) / 100.0F
        uShMaxCandle = uSH * kp
        uShMinCandle = uSH / kp

        Dim showcandles As Boolean = NewSampleMarker AndAlso _
                                     Actual_Precision < 1000 AndAlso _
                                     btn_ShowCandlesticks.Checked
        NewSampleMarker = False

        If Not MeasureIsStarted Then
            showcandles = False
        End If

        ' ------------------------------------------------------------------------------ vertical divisions
        Static oldTimeCounter As Int32 = 0
        Dim VerticalDivisionLength As Int32 = 0
        If TimeCounter <> oldTimeCounter Then
            lbl_Time.Text = Date.Now.ToString("yyyy/MM/dd HH':'mm':'ss ")
            If Scroll_Speed > 5 Then
                VerticalDivisionLength = 3
                If TimeCounter Mod 5 = 0 Then
                    VerticalDivisionLength = 8
                    If TimeCounter Mod 10 = 0 Then
                        VerticalDivisionLength = 16
                        If TimeCounter = 60 Then
                            TimeCounter = 0
                            VerticalDivisionLength = 20
                        End If
                    End If
                End If
            Else
                ' 5 = 1 h
                ' 4 = 12 h
                ' 3 = 1 day
                ' 2 = 7 days
                ' 1 = 30 days
                VerticalDivisionLength = 0
                ' --------------------------------------- every minute for 1 hour (60 divisions)
                If Scroll_Speed = 5 Then
                    If TimeCounter Mod 60 = 0 Then
                        VerticalDivisionLength = 8
                    End If
                End If
                ' --------------------------------------- every hour (12 or 24 divisions)
                If Scroll_Speed <= 4 And Scroll_Speed >= 3 Then
                    If TimeCounter Mod 3600 = 0 Then
                        VerticalDivisionLength = 16
                    End If
                End If
                ' --------------------------------------- every day (7 or 30 divisions)
                If Scroll_Speed < 3 Then
                    If TimeCounter Mod 3600 * 24 = 0 Then
                        VerticalDivisionLength = 20
                    End If
                End If
            End If
            oldTimeCounter = TimeCounter
        End If
        If Flag_ShowStartMeasure_VerticalDivision Then VerticalDivisionLength = 9999
        Flag_ShowStartMeasure_VerticalDivision = False

        ' ------------------------------------------------------------------------------ add data to fifo
        GraphicWindowFifo.AddElement(Smooted_uSh, _
                                     showcandles, _
                                     uShMaxCandle, _
                                     uShMinCandle, _
                                     VerticalDivisionLength)

        ' ------------------------------------------------------------------------------ plot graph
        RollingGraph_PlotGraph(pbox_ScrollingScope, _
                               Scroll_Speed, _
                               Smooted_uSh, _
                               showcandles, _
                               uShMaxCandle, _
                               uShMinCandle, _
                               VerticalDivisionLength)
    End Sub


    Private Sub RedrawGraph()
        If Me.WindowState = FormWindowState.Minimized Then Return

        Static working As Boolean = False
        If working Then Return
        working = True
        ' ------------------------------------------------------------------ redraw background
        pbox_ScrollingScope.Image = Nothing

        RollingGraph_PlotGraph(pbox_ScrollingScope, _
                               Scroll_Speed, _
                               Smooted_uSh, _
                               False, _
                               0, _
                               0, _
                               0, _
                               False)

        ' ------------------------------------------------------------------ redraw single points
        Dim ShowCandles As Boolean
        Dim Value As Single
        Dim MaxCandle As Single
        Dim MinCandle As Single
        Dim VerticalDivisionLength As Int32
        Dim VerticalDivisionColor As Int32
        RedrawSinglePointPositionX = pbox_ScrollingScope.Image.Width - 1
        '
        For i As Int32 = 1 To GraphicWindowFifo.Length - 1
            GraphicWindowFifo.GetElement(i, Value, ShowCandles, MaxCandle, MinCandle, _
                                         VerticalDivisionLength, VerticalDivisionColor)
            If Value = 0 Then Exit For
            If Not btn_ShowCandlesticks.Checked Then ShowCandles = False
            RollingGraph_PlotGraph(pbox_ScrollingScope, _
                                   Scroll_Speed, _
                                   Value, _
                                   ShowCandles, _
                                   MaxCandle, _
                                   MinCandle, _
                                   VerticalDivisionLength, _
                                   True)
            If RedrawSinglePointPositionX <= 1 Then Exit For
        Next
        '
        RollingGraph_OldPositionY = 9999999
        working = False
    End Sub

    ' ---------------------------------------------------------------------- detect size changed and redraw graph
    Private OldWindowState As FormWindowState
    Private FlagSizeChanged As Boolean = False
    Private Sub Form1_ClientSizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ClientSizeChanged
        If Not EventsAreEnabled Then Return
        If WindowState <> OldWindowState Then
            'RedrawGraph()
            InvalidateGraph = True
        Else
            FlagSizeChanged = True
        End If
        OldWindowState = WindowState
    End Sub
    Private Sub Form1_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        If Not EventsAreEnabled Then Return
        If FlagSizeChanged Then
            FlagSizeChanged = False
            RedrawGraph()
        End If
    End Sub

End Class